package dev.shadowsoffire.apotheosis.spawn.modifiers;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerStat;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerStats;
import dev.shadowsoffire.apotheosis.spawn.modifiers.StatModifier;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerTile;
import java.util.function.BiConsumer;
import java.util.function.Function;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.CommonComponents;
import net.minecraft.network.chat.Component;

class BoolStat extends SpawnerStats.Base<Boolean> {
  private final Codec<StatModifier<Boolean>> modifierCodec;
  
  private BoolStat(String id, Function<ApothSpawnerTile, Boolean> getter, BiConsumer<ApothSpawnerTile, Boolean> setter) {
    super(id, getter, setter);
    this.modifierCodec = RecordCodecBuilder.create(inst -> inst.group((App)Codec.BOOL.fieldOf("value").forGetter(StatModifier::value)).apply((Applicative)inst, ()));
  }
  
  public Codec<StatModifier<Boolean>> getModifierCodec() {
    return this.modifierCodec;
  }
  
  public Component getTooltip(ApothSpawnerTile spawner) {
    return ((Boolean)getValue(spawner)).booleanValue() ? (Component)name().m_130940_(ChatFormatting.DARK_GREEN) : CommonComponents.f_237098_;
  }
  
  public boolean apply(Boolean value, Boolean min, Boolean max, ApothSpawnerTile spawner) {
    boolean old = ((Boolean)this.getter.apply(spawner)).booleanValue();
    this.setter.accept(spawner, value);
    return (old != ((Boolean)this.getter.apply(spawner)).booleanValue());
  }
}
